// dcs900.h: interface for the dcs900 class.
//WIFIBOT laurent@wifibot.com
//////////////////////////////////////////////////////////////////////
#include "../IJL/include/ijl.h" //Lib Jpeg
#include "../opencv/cv/include/cv.h" //Lib OpenCV
#include "../tools/mutex.h"

#if !defined(AFX_DCS900_H__683EC0A0_331A_48F9_9C79_FA707DDB1BDD__INCLUDED_)
#define AFX_DCS900_H__683EC0A0_331A_48F9_9C79_FA707DDB1BDD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class dcs900  
{
public:
	dcs900();
	virtual ~dcs900();
	void OnVideoOn();
	void OnVideoOff();
	void MjpegPtuCmd(char*cmd);
	void OnVideoPtuLeft();
	void OnVideoPtuRight();
	void OnVideoPtuUp();
	void OnVideoPtuDown();
	void OnVideoPtuHome();
	void init(HWND hwnd,CDC *dc,CString ip,CString p,CString mjpegtype);
	bool videoproc;
private:
	volatile bool VideoRun;
	void VideoThread(void);
	static UINT VideoThread(LPVOID p);
	void RCVCam();
	void RCVCamTalitor();
	void RCVCamTalitor42();
	void VideoProc();
	void Paint();
	void Left();
	int findfirst(int retval);
	int findlast(int retval);
	bool initok;
	int countimg;
	bool go;
	int first;

	CString camip;
	CString port;
	CDC *hdc;
	HWND myhwnd;
	BYTE* jpegtemp;
	char szMessage[5000];
	char szCompleteImage[300000];
	char szCompleteImagetmp[300000];

	JPEG_CORE_PROPERTIES jpeg;
	SOCKET	skSocket;
	char DataPacket[128];		// Data Packet to Transmit
	char DataPacket2[800];		// Data Packet to Transmit
	char DataPacketPtu[800];		// Data Packet to Transmit
	char szAux[15];
	
	FILE *stream;
	int imagewidth;
	int imageheight;
	bool rcvok;
	Mutex mutexjpeg;

	BITMAPINFO bi;
	int typemjpeg;
};

#endif // !defined(AFX_DCS900_H__683EC0A0_331A_48F9_9C79_FA707DDB1BDD__INCLUDED_)
