//WIFIBOT laurent@wifibot.com

#include "./IPcamera/mpeg4ocx.h"
#include "./IPcamera/videotools.h"
#include "./IPcamera/dcs900.h"
#include "./IPcamera/WifibotLab.h"
#include "./control/Joystick.h"
#include "./control/joy_virtual.h"
#include "./robot/WifibotClient.h"
#include "./opencv/cv/include/cv.h" //Lib OpenCV
#include "./IPcamera/EventNotifySink.h"
#include "./IPcamera/cgif89a.h"
#include "./SetUp/wifibotwin.h"
#include "./SensorsView/winView.h"
#include "./tools/keyboard.h"
#include "./tools/dot/dotgraph.h"
#include "./tools/meter/analogmeter.h"
#include "./tools/ping.h"
#include "./tools/SNR/snr.h"
#include "./control/wii/wii.h"

CLSID const& GetVatClsid()//MPEG4 PTU
	{
		static CLSID const clsid
			= { 0x98264495, 0x6376, 0x443C, { 0x93, 0x40, 0x29, 0x96, 0x3, 0x8B, 0xD1, 0x43 } };
		return clsid;
	}

CLSID const& GetMJPEGPTUClsid()//MJPEG PTU
	{
		static CLSID const clsid
			= { 0x31150a86, 0xbba, 0x409f, { 0xbe, 0xb4, 0xf3, 0x92, 0x2d, 0x10, 0xbf, 0x34 } };
		return clsid;
	}

//#define MPEG4OCX //Camera MPEG4 PAN/TILT
//#define MJPEG //Camera DCS900
#define MJPEGPTU//Camera MJPEG PAN/TILT

CEventNotifySink	m_eventSink;
DWORD				m_dwCookie;
afx_msg void OnBnClickedCancel();

bool activexmjpegok=false;
bool activexmpeg4ok=false;

bool videoproc=false;
bool videoON=false;

bool th0;

CVactrl1 *m_ControlWrapper = new CVactrl1;//Une MPEG4 PTU
CGif89a *m_ControlWrapperPTU = new CGif89a;//Une MJPEG PTU
dcs900 mydcs900;//Une DCS900
WifibotLab mywebcam;
//Cwifibot_Joy_Window *joywindow= new Cwifibot_Joy_Window;//Un joystick virtuel

Joystick joystick;//Un joystick USB
WifibotClient wifibotsc12;//Un robot WIFIBOTSC12
SensorData mySensors;//Une structure capteurs 

wifibotwin setupwin;
WinView	speedview;
JoyVirtual virtualjoy;

int timeout=200,countt=0,dog=60;

DotGraph mydot;

CRect m_rectLeftMeter;
CAnalogMeter m_meterLeft;

CPing myping;
bool pingrobot=false;
bool pingcam=false;

bool const_speed=false;

SNR mysnr;

int sharpl=0,sharpr=0;

int SharpLUT[]={150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,150,103,102,101,100,99,
          96,95,90,88,87,86,85,84,83,82,81,80,79,77,75,74,73,72,71,70,69,68,67,66,65,65,64,64,63,62,61,61,60,60,59,59,58,58,57,57,56,56,56,55,55,55,54,54,54,53,
          53,53,52,52,51,51,50,50,49,49,49,48,48,47,47,46,46,46,45,45,44,44,43,43,42,42,41,41,41,40,40,40,39,39,39,39,39,38,38,
                  38,38,37,37,37,37,36,36,36,36,35,35,35,35,34,34,34,34,34,34,33,33,33,33,32,32,32,32,32,31,31,31,31,30,30,30,30,30,30,30,
          30,29,29,29,29,29,29,29,28,28,28,28,28,28,27,27,27,27,27,27,27,26,26,26,26,25,25,25,25,25,25,24,24,24,24,24,23,23,23,
          23,23,23,22,22,22,22,22,21,21,21,21,21,21,20,20,20,20,19,19,19,19,19,19,18,18,18,18,18,18,17,17,17,16,16,15,15};
wii mywii;
int UDP;
